<?php
/**
* last.fm - Ein Joomla Modul, welches die last.fm Playlist mittels SimpleXML anzeigt.
* @version 1.0.4
* @package last.fm
* @license Released under the terms of the GNU General Public License
* (see LICENSE.php in the Joomla! root directory)
* @copyright (C) 2006-2007 Benedikt Hopmann
* http://www.benedikt-hopmann.de - <lastfm [at] benedikt-hopmann [dot] de>
* Alle Rechte vorbehalten.
*
* Basierend auf Code von:
* 1. Audioscrobbler/Last.fm webservices xml PHP code - Copyright (C) 2006 Frederik M.J.V.
*    (http://freqmod.dyndns.org/asxmldm/). All rights reserved.
* 2. Audioscrobbler/Last.fm webservices PHP code - Copyright (C) 2005 Brad Cavanagh
*    (brad.cavanagh@gmail.com). All rights reserved.
* 3. wz_tooltip - Copyright (C) 2002-2005 Walter Zorn (http://www.walterzorn.com).
*    All rights reserved.
* 4. TimeAgo Funktion von tristan@trinicle.net
*
* Copyright der verwendeten Grafiken:
* Die Grafiken as_footer.gif & lastfm_footer.gif unterliegen dem
* Copyright von last.fm bzw. audioscrobbler.
* Das last.fm for Joomla! Logo enthlt Grafiken von last.fm und Joomla!
* und unterliegt deren Copyright.
*
* Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der
* GNU General Public License, wie von der Free Software Foundation verffentlicht,
* weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder
* (nach Ihrer Option) jeder spteren Version.
*
* Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von
* Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie
* der MARKTREIFE oder der VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK.
* Details finden Sie in der GNU General Public License.
*
* Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
* Programm erhalten haben. Falls nicht, schreiben Sie an die
* Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
*/

# Direkten Zugriff verbieten
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

# Hole Parameter - hier bitte nichts ndern!
$username   			= $params->get( 'username' );
$artist 			= $params->get( 'artist' );
$title   			= $params->get( 'title' );
$show_popup			= $params->get( 'show_popup' );
$max    			= $params->get( 'max' );
$list   			= $params->get( 'list' );
$base_element			= $params->get( 'base_element' );
$each_element     		= $params->get( 'each_element','li' );
$stats    			= $params->get( 'stats' );
$show_date    			= $params->get( 'show_date' );
$dateformat    			= $params->get( 'dateformat','%d. %b. %Y @ %H:%M' );
$dateformat_week		= $params->get( 'dateformat_week','%d. %b.' );
$show_image			= $params->get( 'show_image' );
$image				= $params->get( 'image','40' );
$as_footer    			= $params->get( 'as_footer' );
$test_load			= $params->get( 'test_load' );
$fm_lang			= $mosConfig_lang;
$lastfm_version			= '1.0.4'; # Diese last.fm for Joomla! Version

# Setze Sprache anhand der Systemeinstellung, bisher entweder Deutsch oder Englisch (default)
switch ($fm_lang) {
case "german":
case "germanf":
case "germani":
DEFINE("_php_version","Die PHP Version ");
DEFINE("_php_version_end"," wird leider nicht unterst&uuml;zt!<br /><b>PHP 5 wird ben&ouml;tigt</b>.");
DEFINE("_username","Bitte erst den last.fm Benutzernamen angeben!");
DEFINE("_artist","Bitte erst den K&uuml;nstler angeben!");
DEFINE("_artisttoptracks","Meist geh&ouml;rte Titel von &quot;".htmlentities($artist)."&quot;:");
DEFINE("_artisttopalbums","Meist geh&ouml;rte Alben von &quot;".htmlentities($artist)."&quot;:");
DEFINE("_artistfans","Die gr&ouml;&szlig;ten Fans von &quot;".htmlentities($artist)."&quot;:");
DEFINE("_similar","Benutzer die &quot;".htmlentities($artist)."&quot; h&ouml;ren, h&ouml;ren auch:");
DEFINE("_topartists","Meine Top-K&uuml;nstler:");
DEFINE("_topalbums","Meine Top-Alben:");
DEFINE("_toptracks","Meine Top-Titel:");
DEFINE("_tags","Meine Tags:");
DEFINE("_friends","Meine Freunde:");
DEFINE("_neighbours","Meine Nachbarn:");
DEFINE("_weeklyartistchart","Top-K&uuml;nstler der letzten Woche:");
DEFINE("_weeklyalbumchart","Top-Alben der letzten Woche:");
DEFINE("_weeklytrackchart","Top-Titel der letzten Woche:");
DEFINE("_recenttracks","Gerade l&auml;uft:");
DEFINE("_dir_writable","Das Cacheverzeichnis ist nicht beschreibbar!\n");
DEFINE("_change_modtime_begin","Modifikations-Zeit von ");
DEFINE("_change_modtime_end"," konnte nicht ge&auml;ndert werden. Bitte Dateirechte und Eigent&uuml;mer &uuml;berpr&uuml;fen!\n");
DEFINE("_cachefile","Kann Cachedatei ");
DEFINE("_write_cachefile_end"," nicht zum Schreiben &ouml;ffnen!\n");
DEFINE("_read_cachefile_end"," nicht zum Lesen &ouml;ffnen!\n");
DEFINE("_as_net","Audioscrobbler.com ist nicht erreichbar!\n");
DEFINE("_error","Es ist ein Fehler aufgetreten!\n");
DEFINE("_sek"," Sekunde");
DEFINE("_sek_pl"," Sekunden");
DEFINE("_min"," Minute");
DEFINE("_min_pl"," Minuten");
DEFINE("_std"," Stunde");
DEFINE("_std_pl"," Stunden");
DEFINE("_tag"," Tag");
DEFINE("_tag_pl"," Tagen");
DEFINE("_ja"," Jahr");
DEFINE("_ja_pl"," Jahren");
DEFINE("_time_prefix","vor ");
DEFINE("_time_suffix","");
DEFINE("_time_and"," und ");
DEFINE("_display","Keine Elemente zum Anzeigen vorhanden!");
DEFINE("_release","V&Ouml;:");
$replace_words = array("","Jan","Feb","M&auml;r","Apr","Mai","Jun","Jul","Aug","Okt","Nov","Dez");
break;
default:
DEFINE("_php_version","This PHP version ");
DEFINE("_php_version_end"," is not supported!<br /><b>PHP 5 is needed</b>.");
DEFINE("_username","There's no last.fm username given!");
DEFINE("_artist","There's no artist given!");
DEFINE("_artisttoptracks","Top Tracks of &quot;".htmlentities($artist)."&quot;:");
DEFINE("_artisttopalbums","Top Albums of &quot;".htmlentities($artist)."&quot;:");
DEFINE("_artistfans","Top Fans of &quot;".htmlentities($artist)."&quot;:");
DEFINE("_similar","People who listen to &quot;".htmlentities($artist)."&quot; also listen to:");
DEFINE("_topartists","My Top Artists:");
DEFINE("_topalbums","My Top Albums:");
DEFINE("_toptracks","My Top Tracks:");
DEFINE("_tags","My Tags:");
DEFINE("_friends","My Friends List:");
DEFINE("_neighbours","My Neighbours:");
DEFINE("_weeklyartistchart","Weekly Top Artists:");
DEFINE("_weeklyalbumchart","Weekly Top Albums:");
DEFINE("_weeklytrackchart","Weekly Top Tracks:");
DEFINE("_recenttracks","Recent Tracks:");
DEFINE("_dir_writable","The cache directory is not writable!\n");
DEFINE("_change_modtime_begin","Modification time of ");
DEFINE("_change_modtime_end"," couldn't be changed. Please check file permissions and ownership!\n");
DEFINE("_cachefile","Unable to open cache file ");
DEFINE("_write_cachefile_end"," for writing!\n");
DEFINE("_read_cachefile_end"," for reading!\n");
DEFINE("_as_net","Audioscrobbler.com is unreachable!\n");
DEFINE("_error","An error occurred!\n");
DEFINE("_sek"," second");
DEFINE("_sek_pl"," seconds");
DEFINE("_min"," minute");
DEFINE("_min_pl"," minutes");
DEFINE("_std"," hour");
DEFINE("_std_pl"," hours");
DEFINE("_tag"," day");
DEFINE("_tag_pl"," days");
DEFINE("_ja"," year");
DEFINE("_ja_pl"," years");
DEFINE("_time_prefix","");
DEFINE("_time_suffix"," ago");
DEFINE("_time_and"," and ");
DEFINE("_display","No elements to display!");
DEFINE("_release","Released:");
$replace_words = array("","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Oct","Nov","Dec");
} $md5_value = $lastfm_version;

# Default Einstellungen - bitte nicht ndern!!
if (!isset($write_text)) $write_text = '';
if (!isset($written_text)) $written_text = '';
$checksum = str_replace(chr(36),$md5_value,
  base64_decode('PCEtLQpsYXN0LmZtIGZvciBKb29tbGEhIChWZXJzaW9uICQpIEdOVS9'.
  'HUEwKKGMpIDIwMDYgLSAyMDA3IGh0dHA6Ly93d3cuYmVuZWRpa3QtaG9wbWFubi5kZQotLT4=')
);

# PHP auf Version 5 berprfen
$php_v = phpversion();
if ( $php_v < 5 ) {
echo "<p class=\"lastfm_error\">"._php_version.$php_v._php_version_end."</p>\n";
echo lastfm_footer($as_footer,$lastfm_version,$checksum);
return;
}

# Wenn $max kleiner/gleich 0, wird der Standardwert 10 gewhlt
if( $max <= 0 ) {
    $max = 10;
} $max = $max-1; # da array bei 0 beginnt

# berprfen, ob Benutzername angegeben wurde
if ($username == '') {
echo "<p class=\"lastfm_error\">"._username."</p>\n";
echo lastfm_footer($as_footer,$lastfm_version,$checksum);
return;
}

# berprfen, ob Knstler angegeben wurde
$is_artist_set = array('artisttoptracks','artisttopalbums','artistfans','similar');
if (in_array($list,$is_artist_set)) {
  if ($artist == '') {
      echo "<p class=\"lastfm_error\">"._artist."</p>\n";
      echo lastfm_footer($as_footer,$lastfm_version,$checksum);
      return;
  }
}

# Konvertiert den UTF-8 String der XML-Dateien zu iso-8859-1
function convert($text) {
$text = htmlentities(iconv('UTF-8','ISO-8859-1',$text));
return $text;
}

# Hole die XML-Listen
switch( strtolower( $list ) ) {
  case "artisttoptracks":
    if ($title) { echo '<h4 class="lastfm_title">'._artisttoptracks.'</h4>'; }
    $count_id = "track";
    $filtlist = "artisttoptracks";
  break;
  case "artisttopalbums":
   if ($title) { echo '<h4 class="lastfm_title">'._artisttopalbums.'</h4>'; }
    $count_id = "album";
    $filtlist = "artisttopalbums";
  break;
  case "artistfans":
    if ($title) { echo '<h4 class="lastfm_title">'._artistfans.'</h4>'; }
    $count_id = "user";
    $filtlist = "artistfans";
  break;
  case "similar":
    if ($title) { echo '<h4 class="lastfm_title">'._similar.'</h4>'; }
    $count_id = "artist";
    $filtlist = "similar";
  break;
  case "topartists":
    if ($title) { echo '<h4 class="lastfm_title">'._topartists.'</h4>'; }
    $count_id = "artist";
    $filtlist = "topartists";
  break;
  case "topalbums":
    if ($title) { echo '<h4 class="lastfm_title">'._topalbums.'</h4>'; }
    $count_id = "album";
    $filtlist = "topalbums";
  break;
  case "toptracks":
    if ($title) { echo '<h4 class="lastfm_title">'._toptracks.'</h4>'; }
    $count_id = "track";
    $filtlist = "toptracks";
  break;
  case "tags":
    if ($title) { echo '<h4 class="lastfm_title">'._tags.'</h4>'; }
    $count_id = "tag";
    $filtlist = "tags";
  break;
  case "friends":
    if ($title) { echo '<h4 class="lastfm_title">'._friends.'</h4>'; }
    $count_id = "user";
    $filtlist = "friends";
  break;
  case "neighbours":
    if ($title) { echo '<h4 class="lastfm_title">'._neighbours.'</h4>'; }
    $count_id = "user";
    $filtlist = "neighbours";
  break;
  case "weeklyartistchart":
    if ($title) { echo '<h4 class="lastfm_title">'._weeklyartistchart.'</h4>'; }
    $count_id = "artist";
    $filtlist = "weeklyartistchart";
  break;
  case "weeklyalbumchart":
    if ($title) { echo '<h4 class="lastfm_title">'._weeklyalbumchart.'</h4>'; }
    $count_id = "album";
    $filtlist = "weeklyalbumchart";
  break;
  case "weeklytrackchart":
    if ($title) { echo '<h4 class="lastfm_title">'._weeklytrackchart.'</h4>'; }
    $count_id = "track";
    $filtlist = "weeklytrackchart";
  break;
  default:
    if ($title) { echo '<h4 class="lastfm_title">'._recenttracks.'</h4>'; }
    $count_id = "track";
    $filtlist = "recenttracks";
}

# berprfen, ob Cacheverzeichnis beschreibbar ist
if (!is_writable('cache')) {
echo _dir_writable;
}

# Setze den Namen der Cachedatei
$cachefile = "cache/as_$filtlist.xml";

# Ersetze deutsche Umlaute und Leerzeichen zum Aufrufen der URL
$umlaute = array("","","","","","",""," ");
$replace = array("ae","oe","ue","Ae","Oe","Ue","ss","+");
$artist = str_replace($umlaute, $replace, $artist);

# Setze die URLs fr den Audioscrobbler Webservice
switch(strtolower( $list ) ) {
  case "artisttoptracks":
  case "artisttopalbums":
  case "artistfans":
  case "similar":
    $extra_list = str_replace('artist','',$filtlist);
    $url = "/1.0/artist/$artist/$extra_list.xml";
break;
  case "topartists":
  case "topalbums":
  case "toptracks":
  case "tags":
  case "friends":
  case "neighbours":
  case "weeklyartistchart":
  case "weeklyalbumchart":
  case "weeklytrackchart":
  case "recenttracks":
default:
    $url = "/1.0/user/$username/$filtlist.xml";
break;
}

# Holt XML Datei mittels fsockopen()
function socket_load($host_url, $url) {
 $fp = @fsockopen ($host_url, 80, $errno, $errstr, 20);
   if (!$fp) {
   echo "$errstr ($errno)<br />\n";
   } else {
   fputs ($fp, "GET $url HTTP/1.0\r\nHost: $host_url\r\nUser-Agent: Mozilla/5.0 (X11; U; Linux i686; de; rv:1.8.1.2pre) Gecko/20061023 SUSE/2.0.0.1-0.1 Firefox/2.0.0.2\r\n\r\n");
   if (!isset($data)) $data = '';
   stream_set_blocking($fp, FALSE );
   stream_set_timeout($fp, 20);
   $timeout_info = stream_get_meta_data($fp);
   while (!feof($fp) && !$timeout_info['timed_out']) {
   $data .= fgets($fp,1024);
   }
   fclose ($fp);
  }
 if (isset($data)) {
 $data = explode("\r\n\r\n",$data);
 return $data[1];
 }
}

# Holt XML Datei und schreibt Cache Datei
function xml_load($url,$cachefile) {
$host_url = 'ws.audioscrobbler.com';
 $fp = socket_load($host_url, $url);
  if($fp) {
      $cache_fp = @file_put_contents($cachefile, $fp);
      if($cache_fp) {
          $cache_fp;
      } else {
        echo _cachefile."<b>$cachefile</b>"._write_cachefile_end; return;
      }
   } else {
      echo _as_net;
   }
}

# Wenn die Chachedatei nicht existiert, muss sie auf jeden Fall neu geladen werden
if (!file_exists( $cachefile)) {
   xml_load($url,$cachefile);
}

# Wenn bei last.fm keine 'recenttracks' vorhanden sind, soll die letzte vorhandene
# Cachedatei benutzt werden. Alle anderen Elemente auer 'recenttracks' werden nach
# Ablauf von 30 Sek. (Wert sollte nicht kleine als 30 gesetzt werden) auf jeden Fall
# neu von audioscrobbler.com geladen
if (( file_exists( $cachefile ) && ( time() - filemtime( $cachefile ) > 30 ) )) {
$read_first_line = @file_get_contents($cachefile,FALSE,NULL,0,5);
 if (preg_match('/xml/', $read_first_line)) {
   if (($filtlist == 'recenttracks') && ($test_load)) {
        $cachefile_test_load = "cache/as_".$filtlist."_test_load.xml";
        xml_load($url,$cachefile_test_load);
        $xml_test_load = @simplexml_load_file($cachefile_test_load);
        if ($xml_test_load) {
        $check_count = count($xml_test_load->children())-1;
      if ($check_count >= 0) xml_load($url,$cachefile);
      if (@touch($cachefile));
      else echo _change_modtime_begin."<b>$cachefile</b>"._change_modtime_end;
     } else {
     echo _cachefile."<b>$cachefile_test_load</b>"._read_cachefile_end;
     }
   } else {
   xml_load($url,$cachefile);
   }
 } else {
 xml_load($url,$cachefile);
 }
}


# Konvertiere den UTF-8 String der XML-Dateien zu iso-8859-1
# und ersetze nicht-php-konforme Zeichen
function replace($string) {
    $string = iconv('UTF-8','ISO-8859-1',$string);
    $letter = array("'");
    $replace = array("\'");
    $string = htmlentities(str_replace($letter, $replace, $string));
  return $string;
}

# Funktion Footer
function lastfm_footer($as_footer,$lastfm_version,$sec_string) {
  if ($as_footer == 'logo') {
	$footer = "<center>\n<a href=\"http://www.benedikt-hopmann.de/\"><img src=\"modules/lastfm_images/mod_lastfm.gif\" alt=\"last.fm for Joomla! ($lastfm_version)\" title=\"last.fm for Joomla! ($lastfm_version)\" border=\"0\" /></a>\n</center>\n$sec_string\n";
  } else if ($as_footer == 'as') {
	$footer = "<center>\n<a href=\"http://www.audioscrobbler.net/\"><img src=\"modules/lastfm_images/as_footer.gif\" alt=\"Powered by Audioscrobbler\" title=\"Powered by Audioscrobbler\" border=\"0\" /></a>\n</center>\n$sec_string\n";
  } else if ($as_footer == 'fm') {
	$footer = "<center>\n<a href=\"http://www.last.fm/\"><img src=\"modules/lastfm_images/lastfm_footer.gif\" alt=\"last.fm - the social music revolution\" title=\"last.fm - the social music revolution\" border=\"0\" /></a>\n</center>\n$sec_string\n";
  } else if ($as_footer == 'none') {
	$footer = $sec_string."\n";
  }
 return $footer;
}

# Zeigt die verstrichene Zeit an
function time_ago($timestamp,$show_date) {
  $current_time = time();
  $difference = $current_time - $timestamp;
  if ($show_date == 'short')
  $periods = array('s','m','h','d','a');
  else $periods = array(_sek, _min, _std, _tag, _ja);
  $lengths = array(1, 60, 3600, 86400, 31570560);
  for ($val = count($lengths) - 1; ($val >= 0) && (($number = $difference / $lengths[$val]) <= 1); $val--);
  if ($val < 0) $val = 0;
  $new_time = $current_time - ($difference % $lengths[$val]);
  $number = floor($number);
  if(($number != 1) && ($show_date == 'long')) $periods = array(_sek_pl, _min_pl, _std_pl, _tag_pl, _ja_pl);
  if ($show_date == 'short') {
  if ($val > 1) $suffix = ':';
  } else {
  if ($val > 2) $suffix = ', '; # mit Sekunden $val >= 1
  else if ($val > 1) $suffix = _time_and;
  }
  if (!isset($suffix)) $suffix = '';
  $text = sprintf("%d%s%s", $number, $periods[$val], $suffix);
  if (($val > 1) && (($current_time - $new_time) > 0)){  # mit Sekunden $val >= 1
     $text .= time_ago($new_time,$show_date);
  }
 return $text;
}

# Array der Auswahlmglichkeiten, bei denen die Popups nicht angezeigt werden sollen
$not_to_show = array('recenttracks','artisttoptracks','toptracks','topartists','tags','weeklyartistchart','weeklyalbumchart','weeklytrackchart');

# Bestimmt die Breite eines Bildes
function getsize($data){
  $tempfile = @tempnam("cache", "temp_lastfm_image_");
  $data_neu = preg_replace('/http:\/\/(.*?)\.(.*?)\//','/',$data);
  $host_url = str_replace('http://','',str_replace($data_neu,'',$data));
  $temphandle = socket_load($host_url, $data);
  @file_put_contents($tempfile, $temphandle);
  $imagesize = @getimagesize($tempfile);
  @unlink($tempfile);
  if ($imagesize[0] > 160) {
  return '160';
  } else {
  return $imagesize[0];
  }
}

# ffnen der XML-Datei und Ausgabe...
$fp = @simplexml_load_file($cachefile);
if ($fp) {
    $element_count = count($fp->children())-1;
    if ($element_count < $max) $max = $element_count;
    if ($max <0 ) {
    echo '<p class="lastfm_error">'._display.'</p>';
    echo lastfm_footer($as_footer,$lastfm_version,"\n".$checksum); return;
    }
    if(empty($base_element)) $base_element = 'ul id="lastfm_'.$filtlist.'"';
    echo "\n<$base_element>";
    $printcount = 0;
    while (!is_null($fp)) {
	if ($printcount > $max) break;
      switch ($filtlist) {
      case "artisttoptracks":
	echo '<',$each_element,'><a href="',$fp->track[$printcount]->url,'">',convert($fp->track[$printcount]->name),'</a>';
	if ($stats) {
	echo ' (',$fp->track[$printcount]->reach,')'; }
	echo "</$each_element>\n";
      break;
      case "artisttopalbums":
	echo '<',$each_element,'>';
	if ($show_image) {
	if ($show_popup) {
        $imgwidth = getsize($fp->album[$printcount]->coverart->large);
	echo "<span class=\"lastfm_img\" onmouseover=\"return escape('&lt;p&gt;&nbsp;".replace($fp->album[$printcount]->name)."&lt;/p&gt;&lt;img src=\'".$fp->album[$printcount]->coverart->large."\' width=\'$imgwidth\' alt=\'\' /&gt;')\"><img src=\"",$fp->album[$printcount]->coverart->large,"\" width=\"$image\" height=\"$image\" alt=\"\" /></span>";
	} else {
	echo '<span class="lastfm_img"><img src="',$fp->album[$printcount]->coverart->large,'" width="',$image,'" height="',$image,'" alt="" /></span>';} }
	echo ' <a href="',$fp->album[$printcount]->url,'">',convert($fp->album[$printcount]->name),'</a>';
	if ($stats) {
	echo ' (',$fp->album[$printcount]->reach,')'; }
	if ($show_date) {
	$words = array(", 00:00","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Oct","Nov","Dec");
	echo ', '._release.' ',str_replace($words ,$replace_words , $fp->album[$printcount]->releasedate); }
	echo "</$each_element>\n";
      break;
      case "artistfans":
	echo '<',$each_element,'>';
	if ($show_image) {
	if ($show_popup) {
	foreach ($fp->user[$printcount]->attributes() as $uts=>$fan_name) {
	$fan_name = replace($fan_name); }
	$imgwidth = getsize($fp->user[$printcount]->image);
	echo "<span class=\"lastfm_img\" onmouseover=\"return escape('&lt;p&gt;&nbsp;$fan_name&lt;/p&gt;&lt;img src=\'".$fp->user[$printcount]->image."\' width=\'$imgwidth\' alt=\'\' /&gt;')\"><img src=\"",$fp->user[$printcount]->image,"\" width=\"$image\" height=\"$image\" alt=\"\" /></span>";
	} else {
	echo '<span class="lastfm_img"><img src="',$fp->user[$printcount]->image,'" width="',$image,'" height="',$image,'" alt="" /></span>';} }
        foreach ($fp->user[$printcount]->attributes() as $uts=>$fan_name) {
	echo ' <a href="',$fp->user[$printcount]->url,'">',convert($fan_name),'</a>'; }
	if ($stats) {
	echo ' (',$fp->user[$printcount]->weight,')'; }
	echo "</$each_element>\n";
      break;
      case "similar":
	echo '<',$each_element,'>';
	if ($show_image) {
	if ($show_popup) {
	$imgwidth = getsize($fp->artist[$printcount]->image);
	echo "<span class=\"lastfm_img\" onmouseover=\"return escape('&lt;p&gt;&nbsp;".replace($fp->artist[$printcount]->name)."&lt;/p&gt;&lt;img src=\'".$fp->artist[$printcount]->image."\' width=\'$imgwidth\' alt=\'\' /&gt;')\"><img src=\"",$fp->artist[$printcount]->image,"\" width=\"$image\" height=\"$image\" alt=\"\" /></span>";
	} else {
	echo '<span class="lastfm_img"><img src="',$fp->artist[$printcount]->image,'" width="',$image,'" height="',$image,'" alt="" /></span>';} }
       	echo ' <a href="',$fp->artist[$printcount]->url,'">',convert($fp->artist[$printcount]->name),'</a>';
	if ($stats) {
	echo ' (',$fp->artist[$printcount]->match,'%)'; }
	echo "</$each_element>\n";
      break;
      case "toptracks":
	echo '<',$each_element,'><a href="',$fp->track[$printcount]->url,'">',convert($fp->track[$printcount]->artist),' - ',convert($fp->track[$printcount]->name),'</a>';
	if ($stats) {
	echo ' (',$fp->track[$printcount]->playcount,')'; }
	echo "</$each_element>\n";
      break;
      case "topartists":
       	echo '<',$each_element,'><a href="',$fp->artist[$printcount]->url,'">',convert($fp->artist[$printcount]->name),'</a>';
	if ($stats) {
	echo ' (',$fp->artist[$printcount]->playcount,')'; }
	echo "</$each_element>\n";
      break;
      case "topalbums":
	echo '<',$each_element,'>';
	if ($show_image) {
	if ($show_popup) {
	$imgwidth = getsize($fp->album[$printcount]->image->large);
	echo "<span class=\"lastfm_img\" onmouseover=\"return escape('&lt;p&gt;&nbsp;".replace($fp->album[$printcount]->artist)."&nbsp;-&nbsp;".replace($fp->album[$printcount]->name)."&lt;/p&gt;&lt;img src=\'".$fp->album[$printcount]->image->large."\' width=\'$imgwidth\' alt=\'\' /&gt;')\"><img src=\"",$fp->album[$printcount]->image->large,"\" width=\"$image\" height=\"$image\" alt=\"\" /></span>";
	} else {
	echo '<span class="lastfm_img"><img src="',$fp->album[$printcount]->image->large,'" width="',$image,'" height="',$image,'" alt="" /></span>';
	} }
	echo ' <a href="',$fp->album[$printcount]->url,'">',convert($fp->album[$printcount]->artist),' - ',convert($fp->album[$printcount]->name),'</a>';
	if ($stats) {
	echo ' (',$fp->album[$printcount]->playcount,')'; }
	echo "</$each_element>\n";
      break;
      case "tags":
        echo '<',$each_element,'><a href="',$fp->tag[$printcount]->url,'">',convert($fp->tag[$printcount]->name),'</a>';
	if ($stats) {
	echo ' (',$fp->tag[$printcount]->count,')'; }
	echo "</$each_element>\n";
      break;
      case "friends":
	echo '<',$each_element,'>';
	if ($show_image) {
	if ($show_popup) {
	$imgwidth = getsize($fp->user[$printcount]->image);
	foreach ($fp->user[$printcount]->attributes() as $uts=>$friend_name) {
	$friend_name = replace($friend_name); }
	echo "<span class=\"lastfm_img\" onmouseover=\"return escape('&lt;p&gt;&nbsp;$friend_name&lt;/p&gt;&lt;img src=\'".$fp->user[$printcount]->image."\' width=\'$imgwidth\' alt=\'\' /&gt;')\"><img src=\"",$fp->user[$printcount]->image,"\" width=\"$image\" height=\"$image\" alt=\"\" /></span>";
	} else {
	echo '<span class="lastfm_img"><img src="',$fp->user[$printcount]->image,'" width="',$image,'" height="',$image,'" alt="" /></span>'; } }
        foreach ($fp->user[$printcount]->attributes() as $uts=>$friend_name) {
	echo " <a href=\"".$fp->user[$printcount]->url."\">".convert($friend_name)."</a></$each_element>\n"; }
      break;
      case "neighbours":
	echo '<',$each_element,'>';
	if ($show_image) {
	if ($show_popup) {
	$imgwidth = getsize($fp->user[$printcount]->image);
	foreach ($fp->user[$printcount]->attributes() as $uts=>$neighbour_name) {
	$neighbour_name = replace($neighbour_name); }
	echo "<span class=\"lastfm_img\" onmouseover=\"return escape('&lt;p&gt;&nbsp;$neighbour_name&lt;/p&gt;&lt;img src=\'".$fp->user[$printcount]->image."\' width=\'$imgwidth\' alt=\'\' /&gt;')\"><img src=\"",$fp->user[$printcount]->image,"\" width=\"$image\" height=\"$image\" alt=\"\" /></span>";
	} else {
	echo '<span class="lastfm_img"><img src="',$fp->user[$printcount]->image,'" width="',$image,'" height="',$image,'" alt="" /></span>'; } }
	foreach ($fp->user[$printcount]->attributes() as $uts=>$neighbour_name) {
	echo ' <a href="',$fp->user[$printcount]->url,'">',convert($neighbour_name),'</a>'; }
	if ($stats) {
	echo ' (',$fp->user[$printcount]->match,'%)'; }
	echo "</$each_element>\n";
      break;
      case "weeklyartistchart":
	echo '<',$each_element,'><a href="',$fp->artist[$printcount]->url,'">',convert($fp->artist[$printcount]->name),'</a>';
	if ($stats) {
	echo ' (',$fp->artist[$printcount]->playcount,')'; }
	echo "</$each_element>\n";
      break;
      case "weeklyalbumchart":
	echo '<',$each_element,'><a href="',$fp->album[$printcount]->url,'">',convert($fp->album[$printcount]->artist),' - ',convert($fp->album[$printcount]->name),'</a>';
	if ($stats) {
	echo ' (',$fp->album[$printcount]->playcount,')'; }
	echo "</$each_element>\n";
      break;
      case "weeklytrackchart":
	echo '<',$each_element,'>',convert($fp->track[$printcount]->artist),' - <a href="',$fp->track[$printcount]->url,'">',convert($fp->track[$printcount]->name),'</a>';
	if ($stats) {
	echo ' (',$fp->track[$printcount]->playcount,')'; }
	echo "</$each_element>\n";
      break;
      case "recenttracks":
       	echo '<',$each_element,'>',convert($fp->track[$printcount]->artist),' - <a href="',$fp->track[$printcount]->url,'">',convert($fp->track[$printcount]->name),'</a>';
	if ($show_date) {
	foreach ($fp->track[$printcount]->date->attributes() as $uts=>$timestamp) {
  	$timestamp = str_replace(' ', '', $timestamp);
  	$playtime = strftime($dateformat, $timestamp);
	if ($show_date == 'short' || $show_date == 'long') {
	echo ', ',_time_prefix.time_ago($timestamp,$show_date)._time_suffix;
	} else {
	echo ', ',$playtime; } } }
	echo "</$each_element>\n";
      break;
      }
      $written_text .= $write_text;
      $printcount++;
    }

# Entferne id oder class Elemente im Schlusstag
$classes = array('/ (.*)="(.*)"/is','/ (.*)=\'(.*)\'/is');
$replace_classes = array('','');
echo "</".preg_replace($classes,$replace_classes,$base_element).">\n";

} else {
    echo _cachefile.'<b>'.$cachefile.'</b>'._read_cachefile_end;
}

# Zeige Datum der wchentlichen Charts
if ($show_date) {
switch ($filtlist) {
  case "weeklyartistchart":
  case "weeklyalbumchart":
  case "weeklytrackchart":
	$from = strftime($dateformat_week, str_replace(' ', '', $fp['from']));
	$to = strftime($dateformat_week, str_replace(' ', '', $fp['to']));
	echo "<div id=\"lastfm_week\">$from - $to</div>";
  break;
 }
}

# Ausgabe Footer
echo lastfm_footer($as_footer,$lastfm_version,$checksum);

# Wenn Popups angezeigt werden sollen, erfolgt nun die Ausgabe des JavaScript-Codes
if ($show_popup && $show_image && !in_array($filtlist,$not_to_show)) {
?>
<script type="text/javascript">
//<![CDATA[
/* This notice must be untouched at all times.

wz_tooltip.js    v. 3.45

The latest version is available at
http://www.walterzorn.com
or http://www.devira.com
or http://www.walterzorn.de

Copyright (c) 2002-2005 Walter Zorn. All rights reserved.
Created 1. 12. 2002 by Walter Zorn (Web: http://www.walterzorn.com )
Last modified: 17. 2. 2007

Cross-browser tooltips working even in Opera 5 and 6,
as well as in NN 4, Gecko-Browsers, IE4+, Opera 7+ and Konqueror.
No onmouseouts required.
Appearance of tooltips can be individually configured
via commands within the onmouseovers.

LICENSE: LGPL

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License (LGPL) as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

For more details on the GNU Lesser General Public License,
see http://www.gnu.org/copyleft/lesser.html
*/


////////////////  GLOBAL TOOPTIP CONFIGURATION  /////////////////////
var ttAbove       = <?php if (($show_popup == '3') || (($show_popup == '4'))) echo 'true'; else echo 'false';?>;        // tooltip above mousepointer? Alternative: true
var ttBgColor     = "#ffffff";
var ttBgImg       = "";           // path to background image;
var ttBorderColor = "#317082";
var ttBorderWidth = 1;
var ttClickClose  = false;
var ttDelay       = 0;          // time span until tooltip shows up [milliseconds]
var ttFontColor   = "#333";
var ttFontFace    = "arial,helvetica,sans-serif";
var ttFontSize    = "11px";
var ttFontWeight  = "normal";     // alternative: "bold";
var ttLeft        = <?php if (($show_popup == '2') || (($show_popup == '4'))) echo 'false'; else echo 'true';?>;        // tooltip on the left of the mouse? Alternative: true
var ttOffsetX     = 12;           // horizontal offset of left-top corner from mousepointer
var ttOffsetY     = 15;           // vertical offset                   "
var ttOpacity     = 90;          // opacity of tooltip in percent (must be integer between 0 and 100)
var ttPadding     = 0;            // spacing between border and content
var ttShadowColor = "";
var ttShadowWidth = 0;
var ttStatic      = false;        // tooltip NOT move with the mouse? Alternative: true
var ttSticky      = false;        // do NOT hide tooltip on mouseout? Alternative: true
var ttTemp        = 0;            // time span after which the tooltip disappears; 0 (zero) means "infinite timespan"
var ttTextAlign   = "center";
var ttTitleColor  = "#ffffff";    // color of caption text
var ttWidth       = 162;
////////////////////  END OF TOOLTIP CONFIG  ////////////////////////



//////////////  TAGS WITH TOOLTIP FUNCTIONALITY  ////////////////////
// List may be extended or shortened:
var tt_tags = new Array("a","area","b","big","caption","center","code","dd","div","dl","dt","em","h1","h2","h3","h4","h5","h6","i","img","input","li","map","ol","p","pre","s", "select", "small","span","strike","strong","sub","sup","table","td","textarea","th","tr","tt","u","var","ul","layer");
/////////////////////////////////////////////////////////////////////



///////// DON'T CHANGE ANYTHING BELOW THIS LINE /////////////////////
var tt_obj = null,         // current tooltip
tt_ifrm = null,            // iframe to cover windowed controls in IE
tt_objW = 0, tt_objH = 0,  // width and height of tt_obj
tt_objX = 0, tt_objY = 0,
tt_offX = 0, tt_offY = 0,
xlim = 0, ylim = 0,        // right and bottom borders of visible client area
tt_sup = false,            // true if T_ABOVE cmd
tt_sticky = false,         // tt_obj sticky?
tt_wait = false,
tt_act = false,            // tooltip visibility flag
tt_sub = false,            // true while tooltip below mousepointer
tt_u = "undefined",
tt_mf = null,              // stores previous mousemove evthandler
// Opera: disable href when hovering <a>
tt_tag = null;             // stores hovered dom node, href and previous statusbar txt


var tt_db = (document.compatMode && document.compatMode != "BackCompat")? document.documentElement : document.body? document.body : null,
tt_n = navigator.userAgent.toLowerCase(),
tt_nv = navigator.appVersion;
// Browser flags
var tt_op = !!(window.opera && document.getElementById),
tt_op6 = tt_op && !document.defaultView,
tt_op7 = tt_op && !tt_op6,
tt_ie = tt_n.indexOf("msie") != -1 && document.all && tt_db && !tt_op,
tt_ie7 = tt_ie && typeof document.body.style.maxHeight != tt_u,
tt_ie6 = tt_ie && !tt_ie7 && parseFloat(tt_nv.substring(tt_nv.indexOf("MSIE")+5)) >= 5.5,
tt_n4 = (document.layers && typeof document.classes != tt_u),
tt_n6 = (!tt_op && document.defaultView && typeof document.defaultView.getComputedStyle != tt_u),
tt_w3c = !tt_ie && !tt_n6 && !tt_op && document.getElementById,
tt_ce = document.captureEvents && !tt_n6;

function tt_Int(t_x)
{
	var t_y;
	return isNaN(t_y = parseInt(t_x))? 0 : t_y;
}
function wzReplace(t_x, t_y)
{
	var t_ret = "",
	t_str = this,
	t_xI;
	while((t_xI = t_str.indexOf(t_x)) != -1)
	{
		t_ret += t_str.substring(0, t_xI) + t_y;
		t_str = t_str.substring(t_xI + t_x.length);
	}
	return t_ret+t_str;
}
String.prototype.wzReplace = wzReplace;
function tt_N4Tags(tagtyp, t_d, t_y)
{
	t_d = t_d || document;
	t_y = t_y || new Array();
	var t_x = (tagtyp=="a")? t_d.links : t_d.layers;
	for(var z = t_x.length; z--;) t_y[t_y.length] = t_x[z];
	for(z = t_d.layers.length; z--;) t_y = tt_N4Tags(tagtyp, t_d.layers[z].document, t_y);
	return t_y;
}
function tt_Htm(tt, t_id, txt)
{
	var t_bgc = (typeof tt.T_BGCOLOR != tt_u)? tt.T_BGCOLOR : ttBgColor,
	t_bgimg   = (typeof tt.T_BGIMG != tt_u)? tt.T_BGIMG : ttBgImg,
	t_bc      = (typeof tt.T_BORDERCOLOR != tt_u)? tt.T_BORDERCOLOR : ttBorderColor,
	t_bw      = (typeof tt.T_BORDERWIDTH != tt_u)? tt.T_BORDERWIDTH : ttBorderWidth,
	t_ff      = (typeof tt.T_FONTFACE != tt_u)? tt.T_FONTFACE : ttFontFace,
	t_fc      = (typeof tt.T_FONTCOLOR != tt_u)? tt.T_FONTCOLOR : ttFontColor,
	t_fsz     = (typeof tt.T_FONTSIZE != tt_u)? tt.T_FONTSIZE : ttFontSize,
	t_fwght   = (typeof tt.T_FONTWEIGHT != tt_u)? tt.T_FONTWEIGHT : ttFontWeight,
	t_opa     = (typeof tt.T_OPACITY != tt_u)? tt.T_OPACITY : ttOpacity,
	t_padd    = (typeof tt.T_PADDING != tt_u)? tt.T_PADDING : ttPadding,
	t_shc     = (typeof tt.T_SHADOWCOLOR != tt_u)? tt.T_SHADOWCOLOR : (ttShadowColor || 0),
	t_shw     = (typeof tt.T_SHADOWWIDTH != tt_u)? tt.T_SHADOWWIDTH : (ttShadowWidth || 0),
	t_algn    = (typeof tt.T_TEXTALIGN != tt_u)? tt.T_TEXTALIGN : ttTextAlign,
	t_tit     = (typeof tt.T_TITLE != tt_u)? tt.T_TITLE : "",
	t_titc    = (typeof tt.T_TITLECOLOR != tt_u)? tt.T_TITLECOLOR : ttTitleColor,
	t_w       = (typeof tt.T_WIDTH != tt_u)? tt.T_WIDTH  : ttWidth;
	if(t_shc || t_shw)
	{
		t_shc = t_shc || "#c0c0c0";
		t_shw = t_shw || 5;
	}
	if(tt_n4 && (t_fsz == "10px" || t_fsz == "11px")) t_fsz = "12px";

	var t_optx = (tt_n4? '' : tt_n6? ('-moz-opacity:'+(t_opa/100.0)) : tt_ie? ('filter:Alpha(opacity='+t_opa+')') : ('opacity:'+(t_opa/100.0))) + ';';
	var t_y = '<div id="'+t_id+'" style="position:absolute;z-index:1010;';
	t_y += 'left:0px;top:0px;width:'+(t_w+t_shw)+'px;visibility:'+(tt_n4? 'hide' : 'hidden')+';'+t_optx+'">' +
		'<table border="0" cellpadding="0" cellspacing="0"'+(t_bc? (' bgcolor="'+t_bc+'" style="background:'+t_bc+';"') : '')+' width="'+t_w+'">';
	if(t_tit)
	{
		t_y += '<tr><td style="padding-left:3px;padding-right:3px;" align="'+t_algn+'"><font color="'+t_titc+'" face="'+t_ff+'" ' +
			'style="color:'+t_titc+';font-family:'+t_ff+';font-size:'+t_fsz+';"><b>' +
			(tt_n4? '&nbsp;' : '')+t_tit+'</b></font></td></tr>';
	}
	t_y += '<tr><td><table border="0" cellpadding="'+t_padd+'" cellspacing="'+t_bw+'" width="100%">' +
		'<tr><td'+(t_bgc? (' bgcolor="'+t_bgc+'"') : '')+(t_bgimg? ' background="'+t_bgimg+'"' : '')+' style="text-align:'+t_algn+';';
	if(tt_n6) t_y += 'padding:'+t_padd+'px;';
	t_y += '" align="'+t_algn+'"><font color="'+t_fc+'" face="'+t_ff+'"' +
		' style="color:'+t_fc+';font-family:'+t_ff+';font-size:'+t_fsz+';font-weight:'+t_fwght+';">';
	if(t_fwght == 'bold') t_y += '<b>';
	t_y += txt;
	if(t_fwght == 'bold') t_y += '</b>';
	t_y += '</font></td></tr></table></td></tr></table>';
	if(t_shw)
	{
		var t_spct = Math.round(t_shw*1.3);
		if(tt_n4)
		{
			t_y += '<layer bgcolor="'+t_shc+'" left="'+t_w+'" top="'+t_spct+'" width="'+t_shw+'" height="0"></layer>' +
				'<layer bgcolor="'+t_shc+'" left="'+t_spct+'" align="bottom" width="'+(t_w-t_spct)+'" height="'+t_shw+'"></layer>';
		}
		else
		{
			t_optx = tt_n6? '-moz-opacity:0.85;' : tt_ie? 'filter:Alpha(opacity=85);' : 'opacity:0.85;';
			t_y += '<div id="'+t_id+'R" style="position:absolute;background:'+t_shc+';left:'+t_w+'px;top:'+t_spct+'px;width:'+t_shw+'px;height:1px;overflow:hidden;'+t_optx+'"></div>' +
				'<div style="position:relative;background:'+t_shc+';left:'+t_spct+'px;top:0px;width:'+(t_w-t_spct)+'px;height:'+t_shw+'px;overflow:hidden;'+t_optx+'"></div>';
		}
	}
	return(t_y+'</div>');
}
function tt_EvX(t_e)
{
	var t_y = tt_Int(t_e.pageX || t_e.clientX || 0) +
		tt_Int(tt_ie? tt_db.scrollLeft : 0) +
		tt_offX;
	if(t_y > xlim) t_y = xlim;
	var t_scr = tt_Int(window.pageXOffset || (tt_db? tt_db.scrollLeft : 0) || 0);
	if(t_y < t_scr) t_y = t_scr;
	return t_y;
}
function tt_EvY(t_e)
{
	var t_y2;

	var t_y = tt_Int(t_e.pageY || t_e.clientY || 0) +
		tt_Int(tt_ie? tt_db.scrollTop : 0);
	if(tt_sup && (t_y2 = t_y - (tt_objH + tt_offY - 15)) >= tt_Int(window.pageYOffset || (tt_db? tt_db.scrollTop : 0) || 0))
		t_y -= (tt_objH + tt_offY - 15);
	else if(t_y > ylim || !tt_sub && t_y > ylim-24)
	{
		t_y -= (tt_objH + 5);
		tt_sub = false;
	}
	else
	{
		t_y += tt_offY;
		tt_sub = true;
	}
	return t_y;
}
function tt_ReleasMov()
{
	if(document.onmousemove == tt_Move)
	{
		if(!tt_mf && tt_ce) document.releaseEvents(Event.MOUSEMOVE);
		document.onmousemove = tt_mf;
	}
}
function tt_ShowIfrm(t_x)
{
	if(!tt_obj || !tt_ifrm) return;
	if(t_x)
	{
		tt_ifrm.style.width = tt_objW+'px';
		tt_ifrm.style.height = tt_objH+'px';
		tt_ifrm.style.display = "block";
	}
	else tt_ifrm.style.display = "none";
}
function tt_GetDiv(t_id)
{
	return(
		tt_n4? (document.layers[t_id] || null)
		: tt_ie? (document.all[t_id] || null)
		: (document.getElementById(t_id) || null)
	);
}
function tt_GetDivW()
{
	return tt_Int(
		tt_n4? tt_obj.clip.width
		: (tt_obj.offsetWidth || tt_obj.style.pixelWidth)
	);
}
function tt_GetDivH()
{
	return tt_Int(
		tt_n4? tt_obj.clip.height
		: (tt_obj.offsetHeight || tt_obj.style.pixelHeight)
	);
}

// Compat with DragDrop Lib: Ensure that z-index of tooltip is lifted beyond toplevel dragdrop element
function tt_SetDivZ()
{
	var t_i = tt_obj.style || tt_obj;
	if(t_i)
	{
		if(window.dd && dd.z)
			t_i.zIndex = Math.max(dd.z+1, t_i.zIndex);
		if(tt_ifrm) tt_ifrm.style.zIndex = t_i.zIndex-1;
	}
}
function tt_SetDivPos(t_x, t_y)
{
	var t_i = tt_obj.style || tt_obj;
	var t_px = (tt_op6 || tt_n4)? '' : 'px';
	t_i.left = (tt_objX = t_x) + t_px;
	t_i.top = (tt_objY = t_y) + t_px;
	//  window... to circumvent the FireFox Alzheimer Bug
	if(window.tt_ifrm)
	{
		tt_ifrm.style.left = t_i.left;
		tt_ifrm.style.top = t_i.top;
	}
}
function tt_ShowDiv(t_x)
{
	tt_ShowIfrm(t_x);
	if(tt_n4) tt_obj.visibility = t_x? 'show' : 'hide';
	else tt_obj.style.visibility = t_x? 'visible' : 'hidden';
	tt_act = t_x;
}
function tt_DeAlt(t_tag)
{
	if(t_tag)
	{
		if(t_tag.alt) t_tag.alt = "";
		if(t_tag.title) t_tag.title = "";
		var t_c = t_tag.children || t_tag.childNodes || null;
		if(t_c)
		{
			for(var t_i = t_c.length; t_i; )
				tt_DeAlt(t_c[--t_i]);
		}
	}
}
function tt_OpDeHref(t_e)
{
	var t_tag;
	if(t_e)
	{
		t_tag = t_e.target;
		while(t_tag)
		{
			if(t_tag.hasAttribute("href"))
			{
				tt_tag = t_tag
				tt_tag.t_href = tt_tag.getAttribute("href");
				tt_tag.removeAttribute("href");
				tt_tag.style.cursor = "hand";
				tt_tag.onmousedown = tt_OpReHref;
				tt_tag.stats = window.status;
				window.status = tt_tag.t_href;
				break;
			}
			t_tag = t_tag.parentElement;
		}
	}
}
function tt_OpReHref()
{
	if(tt_tag)
	{
		tt_tag.setAttribute("href", tt_tag.t_href);
		window.status = tt_tag.stats;
		tt_tag = null;
	}
}
function tt_Show(t_e, t_id, t_sup, t_clk, t_delay, t_fix, t_left, t_offx, t_offy, t_static, t_sticky, t_temp)
{
	if(tt_obj) tt_Hide();
	tt_mf = document.onmousemove || null;
	if(window.dd && (window.DRAG && tt_mf == DRAG || window.RESIZE && tt_mf == RESIZE)) return;
	var t_sh, t_h;

	tt_obj = tt_GetDiv(t_id);
	if(tt_obj)
	{
		t_e = t_e || window.event;
		tt_sub = !(tt_sup = t_sup);
		tt_sticky = t_sticky;
		tt_objW = tt_GetDivW();
		tt_objH = tt_GetDivH();
		tt_offX = t_left? -(tt_objW+t_offx) : t_offx;
		tt_offY = t_offy;
		if(tt_op7) tt_OpDeHref(t_e);
		if(tt_n4)
		{
			if(tt_obj.document.layers.length)
			{
				t_sh = tt_obj.document.layers[0];
				t_sh.clip.height = tt_objH - Math.round(t_sh.clip.width*1.3);
			}
		}
		else
		{
			t_sh = tt_GetDiv(t_id+'R');
			if(t_sh)
			{
				t_h = tt_objH - tt_Int(t_sh.style.pixelTop || t_sh.style.top || 0);
				if(typeof t_sh.style.pixelHeight != tt_u) t_sh.style.pixelHeight = t_h;
				else t_sh.style.height = t_h+'px';
			}
		}

		xlim = tt_Int((tt_db && tt_db.clientWidth)? tt_db.clientWidth : window.innerWidth) +
			tt_Int(window.pageXOffset || (tt_db? tt_db.scrollLeft : 0) || 0) -
			tt_objW -
			(tt_n4? 21 : 0);
		ylim = tt_Int(window.innerHeight || tt_db.clientHeight) +
			tt_Int(window.pageYOffset || (tt_db? tt_db.scrollTop : 0) || 0) -
			tt_objH - tt_offY;

		tt_SetDivZ();
		if(t_fix) tt_SetDivPos(tt_Int((t_fix = t_fix.split(','))[0]), tt_Int(t_fix[1]));
		else tt_SetDivPos(tt_EvX(t_e), tt_EvY(t_e));

		var t_txt = 'tt_ShowDiv(\'true\');';
		if(t_sticky) t_txt += '{'+
				'tt_ReleasMov();'+
				(t_clk? ('window.tt_upFunc = document.onmouseup || null;'+
				'if(tt_ce) document.captureEvents(Event.MOUSEUP);'+
				'document.onmouseup = new Function("window.setTimeout(\'tt_Hide();\', 10);");') : '')+
			'}';
		else if(t_static) t_txt += 'tt_ReleasMov();';
		if(t_temp > 0) t_txt += 'window.tt_rtm = window.setTimeout(\'tt_sticky = false; tt_Hide();\','+t_temp+');';
		window.tt_rdl = window.setTimeout(t_txt, t_delay);

		if(!t_fix)
		{
			if(tt_ce) document.captureEvents(Event.MOUSEMOVE);
			document.onmousemove = tt_Move;
		}
	}
}
var tt_area = false;
function tt_Move(t_ev)
{
	if(!tt_obj) return;
	if(tt_n6 || tt_w3c)
	{
		if(tt_wait) return;
		tt_wait = true;
		setTimeout('tt_wait = false;', 5);
	}
	var t_e = t_ev || window.event;
	tt_SetDivPos(tt_EvX(t_e), tt_EvY(t_e));
	if(window.tt_op6)
	{
		if(tt_area && t_e.target.tagName != 'AREA') tt_Hide();
		else if(t_e.target.tagName == 'AREA') tt_area = true;
	}
}
function tt_Hide()
{
	if(window.tt_obj)
	{
		if(window.tt_rdl) window.clearTimeout(tt_rdl);
		if(!tt_sticky || !tt_act)
		{
			if(window.tt_rtm) window.clearTimeout(tt_rtm);
			tt_ShowDiv(false);
			tt_SetDivPos(-tt_objW, -tt_objH);
			tt_obj = null;
			if(typeof window.tt_upFunc != tt_u) document.onmouseup = window.tt_upFunc;
		}
		tt_sticky = false;
		if(tt_op6 && tt_area) tt_area = false;
		tt_ReleasMov();
		if(tt_op7) tt_OpReHref();
	}
}
function tt_Init()
{
	if(!(tt_op || tt_n4 || tt_n6 || tt_ie || tt_w3c)) return;

	var htm = tt_n4? '<div style="position:absolute;"></div>' : '',
	tags,
	t_tj,
	over,
	t_b,
	esc = 'return escape(';
	for(var i = tt_tags.length; i;)
	{--i;
		tags = tt_ie? (document.all.tags(tt_tags[i]) || 1)
			: document.getElementsByTagName? (document.getElementsByTagName(tt_tags[i]) || 1)
			: (!tt_n4 && tt_tags[i]=="a")? document.links
			: 1;
		if(tt_n4 && (tt_tags[i] == "a" || tt_tags[i] == "layer")) tags = tt_N4Tags(tt_tags[i]);
		for(var j = tags.length; j;)
		{--j;
			if(typeof (t_tj = tags[j]).onmouseover == "function" && t_tj.onmouseover.toString().indexOf(esc) != -1 && !tt_n6 || tt_n6 && (over = t_tj.getAttribute("onmouseover")) && over.indexOf(esc) != -1)
			{
				if(over) t_tj.onmouseover = new Function(over);
				var txt = unescape(t_tj.onmouseover());
				htm += tt_Htm(
					t_tj,
					"tOoLtIp"+i+""+j,
					txt.wzReplace("& ","&")
				);
				// window. to circumvent the FF Alzheimer Bug
				t_tj.onmouseover = new Function('e',
					'if(window.tt_Show && tt_Show) tt_Show(e,'+
					'"tOoLtIp' +i+''+j+ '",'+
					((typeof t_tj.T_ABOVE != tt_u)? t_tj.T_ABOVE : ttAbove)+','+
					((typeof t_tj.T_CLICKCLOSE != tt_u)? t_tj.T_CLICKCLOSE : ttClickClose)+','+
					((typeof t_tj.T_DELAY != tt_u)? t_tj.T_DELAY : ttDelay)+','+
					((typeof t_tj.T_FIX != tt_u)? '"'+t_tj.T_FIX+'"' : '""')+','+
					((typeof t_tj.T_LEFT != tt_u)? t_tj.T_LEFT : ttLeft)+','+
					((typeof t_tj.T_OFFSETX != tt_u)? t_tj.T_OFFSETX : ttOffsetX)+','+
					((typeof t_tj.T_OFFSETY != tt_u)? t_tj.T_OFFSETY : ttOffsetY)+','+
					((typeof t_tj.T_STATIC != tt_u)? t_tj.T_STATIC : ttStatic)+','+
					((typeof t_tj.T_STICKY != tt_u)? t_tj.T_STICKY : ttSticky)+','+
					((typeof t_tj.T_TEMP != tt_u)? t_tj.T_TEMP : ttTemp)+
					');'
				);
				t_tj.onmouseout = tt_Hide;
				tt_DeAlt(t_tj);
			}
		}
	}
	if(tt_ie6) htm += '<iframe id="TTiEiFrM" src="javascript:false" scrolling="no" frameborder="0" style="filter:Alpha(opacity=0);position:absolute;top:0px;left:0px;display:none;"></iframe>';
	t_b = document.getElementsByTagName? document.getElementsByTagName("body")[0] : tt_db;
	if(t_b && t_b.insertAdjacentHTML) t_b.insertAdjacentHTML("AfterBegin", htm);
	else if(t_b && typeof t_b.innerHTML != tt_u && document.createElement && t_b.appendChild)
	{
		var t_el = document.createElement("div");
		t_b.appendChild(t_el);
		t_el.innerHTML = htm;
	}
	else
		document.write(htm);
	if(document.getElementById) tt_ifrm = document.getElementById("TTiEiFrM");
}
tt_Init();

//]]>
</script>
<?php
}
?>